---
- name: rome | gitlab | Validate vars are provided
  ansible.builtin.assert:
    that:
      - vars[item] != None
  with_items:
    - gitlab_token

- name: rome | gitlab | dependencies
  ansible.builtin.pip:
    name:
      - python-gitlab==2.10.0

- name: rome | gitlab | Set hook url
  ansible.builtin.set_fact:
    hook_url: "http://{{ route_response.result.spec.host }}"

- name: rome | gitlab | Get webhooks list
  uri:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/hooks"
    method: GET
    return_content: yes
    headers:
      Authorization: "Bearer {{ gitlab_token }}"
  register: results

- name: rome | gitlab | Project hook id
  set_fact:
    hook_id: "{{ item.id }}"
  loop: "{{ results.json | list }}"
  when: item.url == hook_url

- name: rome | gitlab | Update project hook
  uri:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/hooks/{{ hook_id }}"
    method: PUT
    return_content: yes
    headers:
      Authorization: "Bearer {{ gitlab_token }}"
    body_format: json
    body:
      id: "{{ project_id }}"
      push_events: true
      url: "{{ hook_url }}"
    status_code: 200
  register: result
  when: hook_id is defined

- name: rome | gitlab | Adding a project hook
  community.general.gitlab_hook:
    api_url: https://gitlab.com/
    api_token: "{{ gitlab_token }}"
    project: redhat/edge/ci-cd/a-team/rome
    hook_url: "{{ hook_url }}"
    token: "{{ gitlab_key }}"
    state: present
    merge_requests_events: yes
    push_events: yes
    hook_validate_certs: no
  when: hook_id is not defined
